GROMACS - Bug #2503

post-submit has warnings
05/16/2018 10:02 PM - Roland Schulz

Status: Closed

Priority: Normal

Assignee: Mark Abraham

Category:

Target version: 2019

Affected version - Difficulty: uncategorized
extra info:

Affected version: git master

Description

http://jenkins.gromacs.org/job/Matrix_PostSubmit_master/OPTIONS=gcc-7%20armhpc-18.2%200penmp%20simd=ARM_NEON_AS
IMD%20release%20host=bs_overdrive_1000,label=bs_overdrive_1000/

since https://gerrit.gromacs.org/c/7780/

Associated revisions

Revision d181859f - 12/03/2018 04:53 PM - Mark Abraham

Move responsibility for PME reduction to its module

We no longer need temporary energy and virial variables that gcc 7 and
8 warn about in release mode. Earlier efforts to avoid these warnings
made pme.h depend on config.h, which is not desirable.

This made possible minor simplifications to testing code.

Noted some TODOs and added some comments. Removed a completed TODO
that had been left behind.

Fixes #2503
Refs #2863

Change-Id: 19a6¢5b12ef5¢c27bd003d3ab9eeeaa75e9574b2dc

History

#1 - 05/17/2018 11:49 PM - Mark Abraham

We know. There's been some attempts to fix it (e.g. disable running tests, introduce getters such as those reverted in that commit). I've even been
working on the kind of better structured reduction that | proposed back in December instead of the version that is currently there. But it's just not a
priority this moment.

#2 - 05/17/2018 11:49 PM - Mark Abraham

- Status changed from New to Accepted
#3 - 05/19/2018 02:46 AM - Szilard Pall
Yeah, no relaese builds with gcc >= 7 (or 6) are warning-free.

Proposal has been to re-introduce the code reverted to fix warnings (in particular as the revert assumed it was only a performance improvement), but
the proposal was not received very well: https:/gerrit.gromacs.org/#/c/7846/

#4 - 05/29/2018 11:22 PM - Mark Abraham
| can't reproduce the sim_util.cpp issue with release mode gcc 7 or gcc 8 on x86. gec 7 release mode built warning free for me. Release with gcc 8
has a host of string handling warnings (at least, and of course those warnings are not dependent the build type).

#5 - 05/30/2018 01:11 PM - Aleksei lupinov
| assume you've set -DGMX_GPU=0FF? Otherwise, | can only think of -DGMX_COMPILER_WARNINGS=ON.

#6 - 05/30/2018 11:10 PM - Mark Abraham
http://jenkins.gromacs.org/job/Matrix_PostSubmit_master/OPTIONS=gcc-7%20armhpc-18.2%20openmp%20simd=ARM_NEON_ASIMD%20release%20host=bs_overdrive_1000,label=bs_overdrive_1000/
http://jenkins.gromacs.org/job/Matrix_PostSubmit_master/OPTIONS=gcc-7%20armhpc-18.2%20openmp%20simd=ARM_NEON_ASIMD%20release%20host=bs_overdrive_1000,label=bs_overdrive_1000/
https://gerrit.gromacs.org/c/7780/
https://gerrit.gromacs.org/#/c/7846/

Aleksei lupinov wrote:

| assume you've set -DGMX_GPU=0OFF?

Yes, because that's what the post-submit config does (but | also see no warnings in release with master, CUDA 9.2 and gcc 7.1, so it's hard to see
where Szilard's claim comes from). | assume the armhpc gcc might be doing something atypical in the configuration of its gcc, but the issue in our
code is worth solving (properly, without creating another issue).

Otherwise, | can only think of -DGMX_COMPILER_WARNINGS=0ON.

Yes | always use -DGMX_DEVELOPER_BUILD=on which has that effect also.

#7 - 05/31/2018 09:32 PM - Szilard Pall

$ module load cmake/3.9.4 fftw/3.3.7-sse2-avx—-avx2-avxl28fma-avx512 hwloc/1.11.6 gcc/7.3

[...]

$ CC=gcc-7 CXX=g++-7 cmake ../ -DCMAKE_PREFIX_PATH="${FFTW_HOME}" -DGMX_CYCLE_SUBCOUNTERS=ON -DGMX_GPU=0ON -D
GMX_USE_OPENCL=0ON && make -7j24

[...]
[ 92%] Building CXX object src/gromacs/CMakeFiles/libgromacs.dir/ewald/pme-pp.cpp.o
In file included from /tmp/gromacs-master/src/gromacs/mdlib/sim_util.cpp:88:0:
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h: In function ‘void do_force (FILE*, const t_commrec*, con
st gmx_multisim_t*, const t_inputrec*, gmx_int64_t, t_nrnb*, gmx_wallcycle_t, gmx_localtop_t*, const gmx_group
s_t*, real (*)[3], gmx::PaddedArrayRef<gmx::BasicVector<float> >, history_t*, gmx::PaddedArrayRef<gmx::BasicVe
ctor<float> >, real (*)[3], const t_mdatoms*, gmx_enerdata_t*, t_fcdata*, gmx::ArrayRef<float>, t_graph*, t_fo
rcerec*, const gmx_vsite_t*, real*, double, const gmx_edsam*, int, DdOpenBalanceRegionBeforeForceComputation,
DdCloseBalanceRegionAfterForceComputation) ’':
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘vir_Q[0]’ may be used uninitialized in
this function [-Wmaybe-uninitialized]

virial_[diml] [dim2] 4= virial[diml] [dim2];
/tmp/gromacs—-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘vir_Q[1l]’ may be used uninitialized in
this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘vir_Q[2]’ may be used uninitialized in
this function [-Wmaybe-uninitialized]

/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘*((void*) (& vir_Q)+12) [0]’' may be used
uninitialized in this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘*((void*) (& vir_Q)+12)[1]’ may be used
uninitialized in this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘*((void*) (& vir_Q)+12)[2]’ may be used
uninitialized in this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘*((void*) (& vir_Q)+24) [0]’' may be used
uninitialized in this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘*((void*) (& vir_Q)+24)[1]’ may be used
uninitialized in this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/mdtypes/forceoutput.h:103:65: warning: ‘*((void*) (& vir_Q)+24) [2]’' may be used
uninitialized in this function [-Wmaybe-uninitialized]

[ 95%] Building CXX object src/gromacs/CMakeFiles/libgromacs.dir/mdrun/tpi.cpp.o
/tmp/gromacs-master/src/gromacs/ewald/pme-gpu-3dfft-ocl.cpp: In member function ‘void GpuParallel3dFft::perfor
m3dFft (gmx_fft_direction)’:
/tmp/gromacs-master/src/gromacs/ewald/pme—gpu-3dfft-ocl.cpp:168:21: warning: ‘outputGrids’ may be used uniniti
alized in this function [-Wmaybe-uninitialized]

handleClfftError (clfftEnqueueTransform(plan, direction,

commandStreams_.size (), commandStreams_.data(),

waitEvents.size (), waitEvents.data(), outEvents,

inputGrids, outputGrids, tempBuffer), "clFFT execution failure");
/tmp/gromacs-master/src/gromacs/ewald/pme-gpu-3dfft-ocl.cpp:168:21: warning: ‘inputGrids’ may be used uninitia
lized in this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/ewald/pme—gpu-3dfft-ocl.cpp:168:21: warning: ‘direction’ may be used uninitial
ized in this function [-Wmaybe-uninitialized]
/tmp/gromacs-master/src/gromacs/ewald/pme-gpu-3dfft-ocl.cpp:168:21: warning: ‘plan’ may be used uninitialized
in this function [-Wmaybe-uninitialized]

And now a few more warnings.
#8 - 05/31/2018 10:23 PM - Mark Abraham

| can now reproduce the warnings with gcc 7.1 and 7.3 on x86 in release mode for an OpenCL or no-GPU build config (as expected). A CUDA build is
warning free everywhere, of course. Apparently | was doing something differently when | tried earlier.

| have a patch in preparation that refactors the reduction code to make these unused variables compile away, but it's not yet in shape for review.

#9 - 11/28/2018 06:32 PM - Mark Abraham

- Target version set to 2019

#10 - 11/28/2018 07:13 PM - Gerrit Code Review Bot

Gerrit received a related patchset '1' for Issue #2503.

Uploader: Mark Abraham (mark.j.abraham@gmail.com)

Change-Id: gromacs~release-2019~19a6¢c5b12ef5c27bd003d3ab9eeeaa75e9574b2dc
Gerrit URL: https://gerrit.gromacs.org/8757

#11 - 11/29/2018 10:49 AM - Mark Abraham
- Status changed from Accepted to Fix uploaded

#12 - 12/03/2018 05:00 PM - Mark Abraham

- Status changed from Fix uploaded to Resolved

Applied in changeset d181859fb5e1da52930a0c05daa9876b65227a63.

#13 - 12/07/2018 02:43 PM - Paul Bauer

- Status changed from Resolved to Closed
